Description

This is a guide on installing a local OpenStreetMap server on FreeBSD 9.

Prepare the Environment

o Make sure the system is up to date:
pkg update && pkg upgrade
e |nstall a few dependencies:

pkg install git ruby ruby2l-gems rubygem-bundler rubygem-rake ImageMagick-noxll python2 gmake
node npm

e Create an osm user

pw add user -n osm -m -s /bin/sh —-c "OpenStreetMap"
e [nstall svgo:

npm install -g svgo
e Create the osm web app directory:

mkdir -p /usr/local/www/osm
chown -R osm:osm /usr/local/www/osm

Install PostgreSQL 9.4

e |nstall PostgreSQL:
pkg install postgresgl94-{server,client,contrib}
e Enable PostgreSQL at boot:

echo 'postgresqgl_enable="YES"' >> /etc/rc.conf
echo 'postgresgl_flags="-w -s -m fast"' >> /etc/rc.conf
echo 'postgresgl_initdb_flags="--encoding=utf-8 --lc-collate=C"' >> /etc/rc.conf
e Edit the login.conf file:

vi /usr/local/etc/login.conf

o And add the following to the end of the file:

postgres:\
:lang=en_US.UTF-8:\
:setenv=LC_COLLATE=C:\
ctc=default:

e Then run to apply the changes:

cap_mkdb login.conf

e |nitialize the database:

service postgresgl initdb

e Start PostgreSQL:

service postgresqgl start

e Edit the postgres config file:

vi /usr/local/pgsqgl/data/postgresqgl.conft

o And modify the following:

listen_addresses = '*!'

e Edit the pg_hba config file:

vi /usr/local/etc/pgsgl/data/pg_hba.conf

o And modify the following:

# TYPE DATABASE USER CIDR-ADDRESS

# Local connections
local all all

# IPv4 local connections:
host all all 127.0.0.1/32

# IPv6 local connections:
host all all ::1/128

# IPv4 connections:
host all all 192.168.10.0/24
* Restart postgresql:

service postgresql restart

Create a new user and database
e Switch to the pgsql user and enter into the psql prompt:
su - pgsqgl
psgl -d templatel

o Create the osmuser user and osm, osm_test, and openstreetmap databases:

CREATE USER osmuser WITH PASSWORD 'SuperSecretPassword';
ALTER USER osmuser CREATEDB;
CREATE DATABASE openstreetmap OWNER osmuser ENCODING 'UTF8';
CREATE DATABASE osm OWNER osmuser ENCODING 'UTF8';
CREATE DATABASE osm_test OWNER osmuser ENCODING 'UTF8';
GRANT ALL PRIVILEGES ON DATABASE "openstreetmap" to osmuser;
GRANT ALL PRIVILEGES ON DATABASE "osm" to osmuser;
GRANT ALL PRIVILEGES ON DATABASE "osm_test" to osmuser;

o Exit from the postgres user

\q
exit

e Enter into the psql prompt for the openstreetmap database:

psgl —-d openstreetmap

o Create the btree_gist postgresqgl extension:

CREATE EXTENSION btree_gist;

o Exit from the postgres user

\q
exit

e Enter into the psql prompt for the osm database:

psgl —-d osm

o Create the btree_gist postgresgl extension:

CREATE EXTENSION btree_gist;

o Exit from the postgres user
\q
exit

* Enter into the psql prompt for the osm_test database:

psgl —-d osm_test

o Create the btree_gist postgresql extension:

CREATE EXTENSION btree_gist;
o Exit from the postgres user

\q
exit

Install OpenStreetMap

® Switch to the osm user:
su — osm
e Get the current OpenStreetMap code:

cd /usr/local/www/osm
git clone git://git.openstreetmap.org/rails.git

e Copy and edit the configuration files

cd rails
cp config/example.application.yml config/application.yml
cp config/example.database.yml config/database.yml

¢ Edit the database.yml file:

vi config/database.yml

o And change the following parameters:

# Using a recent release (9.1 or higher) of PostgreSQL (http://postgresqgl.org/) is recomme
nded.
# See https://github.com/openstreetmap/openstreetmap-website/blob/master/INSTALL.md#databa
se-setup for detailed setup instructions.
#
development:

adapter: postgresqgl

database: openstreetmap

username: osmuser

password: SuperSecretPassword

host: localhost

encoding: utf8

# Warning: The database defined as 'test' will be erased and
# re—-generated from your development database when you run 'rake'.
# Do not set this db to the same as development or production.
test:

adapter: postgresqgl

database: osm_test

username: osmuser

password: SuperSecretPassword

host: localhost

encoding: utf8

production:
adapter: postgresqgl
database: osm
username: osmuser
password: SuperSecretPassword

host: localhost
encoding: utf8

¢ |nstall the gems:

bundle install --path vendor/bundle

e Exit from the osm user, back into the root user:

exit

e Build and configure the libpgosm module

cd /usr/local/www/osm/rails/db/functions
gmake
chown -R osm:osm

e Switch to the pgsql user and enter into the psql prompt:

su - pgsqgl

psgl —-d openstreetmap

o Configure the libpgosm:

CREATE FUNCTION maptile_for_point (int8, int8, int4) RETURNS int4 AS '/usr/local/www/osm/ra

ils/db/functions/libpgosm.so', 'maptile_for_point' LANGUAGE C STRICT;

CREATE FUNCTION tile_for_point (int4, int4) RETURNS int8 AS '/usr/local/www/osm/rails/db/fu

nctions/libpgosm.so', 'tile_for_point' LANGUAGE C STRICT;

o Exit from the postgres user

\q
exit

e Populating the database structure and test it:

su — osm
cd rails

bundle exec rake db:migrate

env RAILS_ENV=production bundle exec rake db:migrate
env RAILS_ENV=test bundle exec rake db:migrate
env RAILS_ENV=test bundle exec rake test

e Generate a secret key for the production environment:
RAILS_ENV=production rake secret >> /usr/local/www/osm/rails/config/secrets.yml
o Edit the secrets.yml file and adjust the production key parameter, removing the <%= ENV["SECRET_KEY_BASE"] %>

string:

vi /usr/local/www/osm/rails/config/secrets.yml

o Adjust the production secret similar to the following:

secret_key_base: 56d21b623£317d434£223dac278£fb919d098b4c7e6a62£0142560564037faed44d74701
6c07b09%a5eal202e45843ef5863aa9lef7ecade018aecd4al8abef3fb1889

® Precompile the production assets:

env RAILS_ENV=production bundle exec rake assets:precompile

Install Phusion Passenger
e |nstall Passenger
portmaster www/rubygem-passenger
o NOTE: Make sure to enable [X]NGINX while configuring rubygem-passenger

o NOTE: Enabling [X]SYMLINK makes upgrading passenger easier later on.
o NOTE: Ruby capabilities can be further extended by using rubygem packages, to search for more packages run:

find /usr/ports/ —-name "rubygem-*"
e Install nginx with passenger support:

cd /usr/ports/www/nginx
make config
portmaster www/nginx

o NOTE: Make sure to enable [X]PASSENGER while configuring nginx

e Start and enable nginx at boot:

echo 'nginx_enable="YES"' >> /etc/rc.conf
service nginx start

e Create a configuration directory to make managing individual server blocks easier
mkdir /usr/local/etc/nginx/conf.d

e Edit the main nginx config file:
vi /usr/local/etc/nginx/nginx.conf
o And add the Passenger config parameters:
#user nobody;
worker_processes 1;
error_log /var/log/nginx-error.log;
events {

worker_connections 1024;

http {
include mime.types;
default_type application/octet-stream;

sendfile on;
#tcp_nopush on;

#tkeepalive_timeout 0;
keepalive_timeout 65;

#gzip on;

# Load Phusion Passenger module globally

passenger_root /usr/local/lib/ruby/gems/2.1/gems/passenger;

passenger_ruby /usr/local/bin/ruby2l;
passenger_max_pool_size 15;
passenger_pool_idle_time 300;

# Load config files from the /etc/nginx/conf.d directory

include /usr/local/etc/nginx/conf.d/*.conf;

® Restart nginx to load passenger:

service nginx restart

e Add a osm.example.com server block:

vi /usr/local/etc/nginx/conf.d/osm.example.com.conf

o Add the following:

server {
listen 80;
server_name osm.example.com;
root /usr/local/www/osm/rails/public;
access_log /var/log/osm.example.com—access.log;
error_log /var/log/osm.example.com-error.log;

passenger_enabled on;
passenger_user osm;
passenger_group osm;

® Restart nginx to load the website config:
service nginx restart

Import Latest Planet File

® Fetch the latest planet file:

fetch http://planet.openstreetmap.org/planet/planet-latest.osm.bz2

Resources

e http://www.openstreetmap.org/
¢ http://wiki.openstreetmap.org/wiki/User:S-s-s_wiki/Creating_a_local OSM_server_under_FreeBSD
¢ https:/qit.openstreetmap.org/rails.qgit/

History

#1 - 01/25/2016 09:32 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress

- % Done changed from 0 to 30

#2 - 01/26/2016 03:15 PM - Daniel Curtis
- Description updated
- % Done changed from 30 to 60

#3 - 01/26/2016 04:06 PM - Daniel Curtis

- Description updated

#4 - 01/26/2016 08:04 PM - Daniel Curtis
- Description updated

- % Done changed from 60 to 80

#5 - 06/04/2017 09:46 PM - Daniel Curtis

- Status changed from In Progress to Suspended
